//
// WtCanvas.js
//
// Copyright  2005, glenn andreas.	 All rights reserved
//


protoCanvas = View({
	_proto : protoView,
	viewClass : 'canvas',
	width : 100,
	height : 100,
	CreateElement : function() {
		var retval = document.createElement('canvas');
		retval.setAttribute('width', this.width);
		retval.setAttribute('height', this.height);
		return retval;
	},
	RefreshView : function() {
		if (this.viewElement.style.left && this.viewElement.style.right) {
			this.viewElement.setAttribute('width', this.viewElement.offsetParent.offsetWidth - parseInt(this.viewElement.style.left) - parseInt(this.viewElement.style.right));
		}
		if (this.viewElement.style.top && this.viewElement.style.bottom) {
			this.viewElement.setAttribute('height',this.viewElement.offsetParent.offsetHeight - parseInt(this.viewElement.style.top) - parseInt(this.viewElement.style.bottom));
		}
		this.ViewDrawScript(this.viewElement.getContext('2d'));
	},
	Dirty : function() {
		wt_Private.NeedToRefreshView(this);
	},
	ViewDrawScript : function(context) {
		// override this to actually draw
	}
});

// to embed several views in a single canvas
protoSharedCanvas = View({
	_proto : protoCanvas,
	viewClass : 'sharedCanvas'
});

protoSubCanvas = View({
	_proto : protoView,
	viewClass : 'subCanvas',
	ViewSetupFormScript : function() {
		protoView.ViewSetupFormScript.call(this);
		// find the shared canvas we are in
	},
	RefreshView : function() {
		// we need to transform to our view
		var context = this.viewElement.getContext('2d');
		this.ViewDrawScript(context);
	}
});


protoStretchBorder = View({
	_proto : protoCanvas,
	viewClass : 'stretchBorder',
	// default to the Default background image, the full width and height of the parent
	imageSrc : 'Default.png',
	viewBounds : SetBounds(0,0,0,0),
	viewJustify : vjParentFullH | vjParentFullV,
	sliceSize : [0,0, 0,0],
	image : null,
	CalcJustify : function() {
		protoCanvas.CalcJustify.call(this);
	},
	ViewSetupFormScript : function() {
		protoCanvas.ViewSetupFormScript.call(this);
		if (!this.image) {
			this.image = new Image();
			this.image.src = this.imageSrc;
		}
	},
	ViewDrawScript : function(context) {
		// override this to actually draw
		if (!this.image.complete) {
			this.Dirty();
			return;
		}
		context.globalCompositeOperation = 'copy';
		var width = this.viewElement.offsetWidth;
		var height = this.viewElement.offsetHeight;
		var leftcap = this.sliceSize[0];
		var rightcap = this.sliceSize[1];
		var topcap = this.sliceSize[2];
		var bottomcap = this.sliceSize[3];
		var hendcaps = leftcap+rightcap;
		var vendcaps = topcap+bottomcap;
		var rightcapstart = this.image.width - rightcap;
		var bottomcapstart = this.image.height - bottomcap;
		var midimagewidth = this.image.width - hendcaps;
		var midimageheight = this.image.height - vendcaps;
		var middestwidth = width - hendcaps;
		var middestheight = height - vendcaps;
		var destrightstart = width - rightcap;
		var destbottomstart = height - bottomcap;

		context.drawImage(this.image,	0,0,leftcap,topcap,							0,0,				leftcap,topcap);
		context.drawImage(this.image,	leftcap,0,midimagewidth,topcap,					leftcap,0,			middestwidth,topcap);
		context.drawImage(this.image,	rightcapstart,0,rightcap,topcap,				destrightstart,0,		rightcap,topcap);

		context.drawImage(this.image,		0,topcap,leftcap,midimageheight,				0,topcap,			leftcap,middestheight);
		context.drawImage(this.image,		leftcap,topcap,midimagewidth,midimageheight,		leftcap,topcap,		middestwidth,middestheight);
		context.drawImage(this.image,		rightcapstart,topcap,rightcap,midimageheight,		destrightstart,		topcap,rightcap,middestheight);

		context.drawImage(this.image,		0,bottomcapstart,leftcap,bottomcap,				0,destbottomstart,	leftcap,bottomcap);
		context.drawImage(this.image,		leftcap,bottomcapstart,midimagewidth,bottomcap,		leftcap,destbottomstart, middestwidth,bottomcap);
		context.drawImage(this.image,		rightcapstart,bottomcapstart,rightcap,bottomcap,	destrightstart,destbottomstart, rightcap,bottomcap);
	},
	ReorientToScreen : function() {
		// change our size
		//this.Dirty();
		protoCanvas.ReorientToScreen.call(this);
		this.RefreshView();
	}
});