//
// WtModal.js
//
// Copyright  2005, glenn andreas.	 All rights reserved
//

protoPanelBackground = View({
	_proto : protoView,
	viewClass : 'panelBackground',
	chromeTopHeight : 16,
	chromeBottomHeight : 24,
	chromeLeftWidth : 20,
	chromeRightWidth : 20,
	chromeImages : ["Chrome/Modal_top_left.png", "Chrome/Modal_top_center.png", "Chrome/Modal_top_right.png",
	"Chrome/Modal_middle_left.png", "Chrome/Modal_middle_center.png", "Chrome/Modal_middle_right.png",
	"Chrome/Modal_bottom_left.png", "Chrome/Modal_bottom_center.png", "Chrome/Modal_bottom_right.png"
	],
	viewStyle : { zIndex: 9000 },
	CreateElement : function() {
		var retval = protoView.CreateElement.call(this);
		var slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeLeftWidth;
		slice.style.left = 0;
		slice.style.height = this.chromeTopHeight;
		slice.style.background = 'url("' + this.chromeImages[0] + '") no-repeat top left';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.left = this.chromeLeftWidth;
		slice.style.right = this.chromeRightWidth;
		slice.style.height = this.chromeTopHeight;
		slice.style.background = 'url("' + this.chromeImages[1] + '") repeat-x top center';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeRightWidth;
		slice.style.right = 0;
		slice.style.height = this.chromeTopHeight;
		slice.style.background = 'url("' + this.chromeImages[2] + '") no-repeat top right';
		retval.appendChild(slice);

		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeLeftWidth;
		slice.style.left = 0;
		slice.style.top = this.chromeTopHeight;
		slice.style.bottom = this.chromeBottomHeight;
		slice.style.background = 'url("' + this.chromeImages[3] + '") repeat-y center left';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.left = this.chromeLeftWidth;
		slice.style.right = this.chromeRightWidth;
		slice.style.top = this.chromeTopHeight;
		slice.style.bottom = this.chromeBottomHeight;
		slice.style.background = 'url("' + this.chromeImages[4] + '") repeat center center';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeRightWidth;
		slice.style.right = 0;
		slice.style.top = this.chromeTopHeight;
		slice.style.bottom = this.chromeBottomHeight;
		slice.style.background = 'url("' + this.chromeImages[5] + '") repeat-y center right';
		retval.appendChild(slice);

		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeLeftWidth;
		slice.style.left = 0;
		slice.style.height = this.chromeBottomHeight;
		slice.style.bottom = 0;
		slice.style.background = 'url("' + this.chromeImages[6] + '") no-repeat bottom left';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.left = this.chromeLeftWidth;
		slice.style.right = this.chromeRightWidth;
		slice.style.height = this.chromeBottomHeight;
		slice.style.bottom = 0;
		slice.style.background = 'url("' + this.chromeImages[7] + '") repeat-x bottom center';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeRightWidth;
		slice.style.right = 0;
		slice.style.height = this.chromeBottomHeight;
		slice.style.bottom = 0;
		slice.style.background = 'url("' + this.chromeImages[8] + '") no-repeat bottom right';
		retval.appendChild(slice);

		return retval;
	}
});


protoModalBackdrop = View({
	_proto : protoCanvas,
	viewClass : 'modalBackdrop',
	viewBounds : SetBounds(0,0,0,0),
	viewJustify : vjParentFullH | vjParentFullV,
	viewStyle : { zIndex: 8999 },
	ViewDrawScript : function(context) {
		var b = this.GlobalBox();
		context.fillStyle = 'rgba(0,0,0, 0.75)';
		context.globalCompositeOperation = 'source-in';
		context.fillRect(0,0,b.right - b.left, b.bottom - b.top);
	}
});
protoModalWindow = View({
	_proto : protoView,
	viewFlags : protoView.viewFlags & (~ vVisible),
	viewStyle : { zIndex: 9000 },
	Close : function() {
		this.Hide();
	},
	ViewHideScript : function() {
		if (this.backdrop) {
			GetRoot().RemoveStepView(this.backdrop);
			this.backdrop = null;
		}
		if (GetRoot().ReopenDrawers) {
			GetRoot().ReopenDrawers();
		}
	},
	ViewShowScript : function() {
		//alert(GetRoot().viewElement.offsetHeight);
		if (GetRoot().CloseDrawers) {
			GetRoot().CloseDrawers();
		}
		if (!this.backdrop) {
			this.backdrop = GetRoot().AddStepView(protoModalBackdrop);
		}
		this.backdrop.Show();
		var children = this.ChildViewFrames();
		for (var i=0;i<children.length;i++) {
			if (parseInt(children[i].viewElement.style.zIndex) < 9000) {
				children[i].viewElement.style.zIndex = parseInt(children[i].viewElement.style.zIndex) + 9000;
			}
		}
		if (this.closeBox) {
			this.closeBox.Show();
		}
	}
});
DeclareChild(protoPanelBackground, protoModalWindow, "background");
